#include "d3d_local.h"


IDirect3DVertexShader9 *D3D_CreateVertexShader (int resourceID, char *entrypoint)
{
	ID3DXBuffer *shaderBuffer = NULL;
	ID3DXBuffer *errorBuffer = NULL;
	IDirect3DVertexShader9 *shaderOut = NULL;

	D3DXMACRO defines[] =
	{
		{"VERTEXSHADER", "1"},
		{NULL, NULL}
	};

	// because there are so many places where this can fail, instead of checking HRESULTs here, we
	// just let the caller check if it got a valid shader returned
	D3DXCompileShaderFromResource (
		GetModuleHandle (NULL),
		MAKEINTRESOURCE (resourceID),
		defines,
		NULL,
		entrypoint,
		"vs_3_0",
		0,
		&shaderBuffer,
		&errorBuffer,
		NULL
	);

	if (shaderBuffer)
	{
		d3d_Device->CreateVertexShader ((DWORD *) shaderBuffer->GetBufferPointer (), &shaderOut);
		shaderBuffer->Release ();
	}

	if (errorBuffer)
	{
		VID_Printf (PRINT_ALL, "Errors compiling %s\n", entrypoint);
		VID_Printf (PRINT_ALL, "%s\n", (char *) errorBuffer->GetBufferPointer ());
		errorBuffer->Release ();
	}

	return shaderOut;
}


IDirect3DPixelShader9 *D3D_CreatePixelShader (int resourceID, char *entrypoint)
{
	ID3DXBuffer *shaderBuffer = NULL;
	ID3DXBuffer *errorBuffer = NULL;
	IDirect3DPixelShader9 *shaderOut = NULL;

	D3DXMACRO defines[] =
	{
		{"PIXELSHADER", "1"},
		{NULL, NULL}
	};

	// because there are so many places where this can fail, instead of checking HRESULTs here, we
	// just let the caller check if it got a valid shader returned
	D3DXCompileShaderFromResource (
		GetModuleHandle (NULL),
		MAKEINTRESOURCE (resourceID),
		defines,
		NULL,
		entrypoint,
		"ps_3_0",
		0,
		&shaderBuffer,
		&errorBuffer,
		NULL
	);

	if (shaderBuffer)
	{
		d3d_Device->CreatePixelShader ((DWORD *) shaderBuffer->GetBufferPointer (), &shaderOut);
		shaderBuffer->Release ();
	}

	if (errorBuffer)
	{
		VID_Printf (PRINT_ALL, "Errors compiling %s\n", entrypoint);
		VID_Printf (PRINT_ALL, "%s\n", (char *) errorBuffer->GetBufferPointer ());
		errorBuffer->Release ();
	}

	return shaderOut;
}


